#!/usr/bin/env python
#-*- coding: iso8859-15 -*-
##########################################################
#               ADQUIRIR ADAM5000TCP v1.0                #
##########################################################
# Autor: Juan Miguel Taboada Godoy                       #
# Fecha: Szczecin, 30 de diciembre de 2007               #
# Descripcin: Fichero de configuracin de Adquisin de  #
# datos mediante ADAM 5000 TCP                           #
# Versin: 2007123001                                    #
#                                                        #
# Codigo fuente bajo licencia GNU/GPL                    #
# Centrologic (Computational Logistic Center)            #
# http://www.centrologic.com - info@centrologic.com      #
##########################################################

# Cargo la configuracion por defecto
from adquirir_adam5000tcp_default import *
from src.lib.REGISTRADORES import *
from src.lib.EVENTS import *
from src.lib.FILE_SIGNALS import *
from src.lib.NET_UDP import *
from src.etcbin.senales import *

# Indica a la clase de senales que nos vamos a usar los IDs
s.not_using_IDs()

# Create class events
eventosEstacion=EVENTS(s)

# === GENERAL ===
# Configuracion PLC1: UDP -> Centrologic
reg_centrologic=[]
reg_centrologic.append("Tiempo_Temperatura")
reg_centrologic.append("Tiempo_Humedad")
reg_centrologic.append("Tiempo_VientoVelocidad")
reg_centrologic.append("Tiempo_VientoDireccion")

# Creo las conexiones de red para el PLC1 - PLC1 UDP->Centrologic
net_udpEstacion=NET_UDP("direccion_IP_del_servidor","tiempo",s,"")
net_udpEstacion.load("Tiempo")
# Creo las conexiones de red para el PLC1 en local - PLC1 UDP->Local
net_udpEstacion_local=NET_UDP("127.0.0.1","tiempo",s,"esta_es_la_clave_encript")
net_udpEstacion_local.load("PLC1")

# Creo los registradores que vamos a usar
registradoresEstacion=REGISTRADORES([FILE_SIGNALS("advantech","tiempo",compress=True),net_udpEstacion,net_udpEstacion_local])

# Creo el PLC1
Estacion=TELEMANDO("Tiempo",registradoresEstacion,eventosEstacion,s)
Estacion.set_debug(True)
Estacion.config(config,"192.168.123.456")
Estacion.load("Tiempo")
Estacion.connect()
listado_telemandos.append(Estacion)
