#!/usr/bin/env python
#-*- coding: iso8859-15 -*-
##########################################################
#                  ADQUIRIR MODBUS v1.0                  #
##########################################################
# Autor: Juan Miguel Taboada Godoy                       #
# Fecha: Szczecin, 30 de diciembre de 2006               #
# Descripcin: Fichero de configuracin de Adquisin de  #
# datos mediante MODBUS                                  #
# Versin: 2006123001                                    #
#                                                        #
# Codigo fuente bajo licencia GNU/GPL                    #
# Centrologic (Computational Logistic Center)            #
# http://www.centrologic.com - info@centrologic.com      #
##########################################################

# Cargo la configuracion por defecto
from adquirir_momentum_default import *
from src.lib.REGISTRADORES import *
from src.lib.FILE_SIGNALS import *
from src.lib.NET_UDP import *
from src.etcbin.senales import *

# === GENERAL ===
# Configuracion PLC1: UDP -> Centrologic
reg_centrologic=[]
reg_centrologic.append("nombre_senal_lugar1_1")
reg_centrologic.append("nombre_senal_lugar1_2")
reg_centrologic.append("nombre_senal_lugar1_3")
# Configuracion PLC1
reg_PLC1=[]
reg_PLC1.append("nombre_senal_lugar1_1")
reg_PLC1.append("nombre_senal_lugar1_2")
reg_PLC1.append("nombre_senal_lugar1_3")
reg_PLC1.append(("nombre_senal_lugar1_4",true))		# Valor REAL
reg_PLC1.append(("nombre_senal_lugar1_5",true))		# Valor REAL
# Configuracion PLC2
reg_PLC2=[]
reg_PLC2.append("nombre_senal_lugar1_6")
reg_PLC2.append("nombre_senal_lugar1_7")
reg_PLC2.append("nombre_senal_lugar1_8")
reg_PLC2.append(("nombre_senal_lugar1_9",True))		# Valor REAL

# Creo las conexiones de red para el PLC1 - lugar1 PLC1 UDP->Centrologic
net_udpPLC1=NET_UDP("direccion_ip_centrologic","plc1",s)
net_udpPLC1.load(reg_centrologic)
# Creo las conexiones de red para el PLC1 en local - lugar1 PLC1 UDP->Local
net_udpPLC1_local=NET_UDP("127.0.0.1","plc1",s)
net_udpPLC1_local.load(reg_PLC1)
# Creo las conexiones de red para el PLC2 en local - lugar1 PLC2 UDP->Local
net_udpPLC2_local=NET_UDP("127.0.0.1","plc2",s)
net_udpPLC2_local.load(reg_PLC2)

# Creo los registradores que vamos a usar
registradoresPLC1=REGISTRADORES([FILE_SIGNALS("momentum","plc1"),net_udpPLC1,net_udpPLC1_local])
registradoresPLC2=REGISTRADORES([FILE_SIGNALS("momentum","plc2"),            net_udpPLC2_local])

# Creo el PLC1
PLC1=TELEMANDO("PCLNumero1",registradoresPLC1,s)
PLC1.set_debug(True)
PLC1.config(config,"direcion_IP_del_PLC_numero_1")
PLC1.load(reg_PLC1)
listado_telemandos.append(PLC1)
# Creo el PLC2
PLC2=TELEMANDO("PLCNumero2",registradoresPLC2,s)
PLC2.set_debug(True)
PLC2.config(config,"direcion_IP_del_PLC_numero_2")
PLC2.load(reg_PLC2)
listado_telemandos.append(PLC2)
