#!/usr/bin/env python
#-*- coding: iso8859-15 -*-
##########################################################
#                  ADQUIRIR RED v1.0                     #
##########################################################
# Autor: Juan Miguel Taboada Godoy                       #
# Fecha: Malaga, 15 de enero de 2007                     #
# Descripcin: Fichero de configuracin de Adquisin de  #
# datos de dispositivos de red                           #
# Versin: 2007011501                                    #
#                                                        #
# Codigo fuente bajo licencia GNU/GPL                    #
# Centrologic (Computational Logistic Center)            #
# http://www.centrologic.com - info@centrologic.com      #
##########################################################

# Cargo la configuracion por defecto
from adquirir_red_default import *
from src.lib.FILE_SIGNALS import *
from src.lib.REGISTRADORES import *
import time

# Creo los registradores que vamos a usar
registradores=REGISTRADORES([FILE_SIGNALS("netstatistics","data/red/netdata")])

# Lugar 1: netdata
t=TELEMANDO("Lugar1",registradores)
t.set_debug(True)
t.config(config)

# ETH0: Red en Trapiche
t.addsignal("eth0",band_in)
t.addsignal("eth0",band_out)

# ETH1: AP Trapiche-Vlez
t.addsignal("eth1",band_in)
t.addsignal("eth1",band_out)

# ETH2: AP Trapiche-Jess
t.addsignal("eth2",band_in)
t.addsignal("eth2",band_out)

# ETH3: AP Trapiche-Filtros
t.addsignal("eth3",band_in)
t.addsignal("eth3",band_out)

# TUN0: TUNEL Red de tneles Axaragua
t.addsignal("tun0",band_in)
t.addsignal("tun0",band_out)

# PINGs
ips=[]
ips.append("www.google.es")		# Internet: Google.es
ips.append("192.168.x.y")		# Otra ip

# Para todos los destinos capturo los datos de red necesarios
for destino in ips:
	# Hay ping?
	t.addsignal(destino,ping_digital)
	# Porcentaje de paquetes perdidos
	t.addsignal(destino,ping_perdidos)
	# Ping maximo
	t.addsignal(destino,ping_maximo)
	# Ping minimo
	t.addsignal(destino,ping_minimo)
	# Ping medio
	t.addsignal(destino,ping_medio)

# Aado el Telemando
listado_telemandos.append(t)
