#!/usr/bin/env python
#-*- coding: iso8859-15 -*-
##########################################################
#                    ADQUIRIR WEB v1.0                   #
##########################################################
# Autor: Juan Miguel Taboada Godoy                       #
# Fecha: Malaga, 15 de febrero de 2007                   #
# Descripcin: Fichero de configuracin de adquisin de  #
# ficheros mediante el protocolo WWW                     #
# Versin: 2007021500                                    #
#                                                        #
# Codigo fuente bajo licencia GNU/GPL                    #
# Centrologic (Computational Logistic Center)            #
# http://www.centrologic.com - info@centrologic.com      #
##########################################################

# Cargo la configuracion por defecto
from adquirir_web_default import *
from src.lib.FILE_SIGNALS import *
from src.lib.REGISTRADORES import *

listado_telemandos=[]

# Creo los registradores que vamos a usar
registradoresINM=REGISTRADORES([FILE_SIGNALS("web","data/web/inm",60*60*24*1-1)])

# Instituto Nacional de Meteorologia
t=TELEMANDO("INM",registradoresINM)
t.config(config,"http://www.inm.es/cgi-bin/locali.cgi?ig=29920")
# Filtro de la fecha
t.signal("Fecha")
t.addfilter("Velez-Malaga - MALAGA","(hora local peninsular)",2)
t.addfilter(0)
t.cleaner('lambda x:x[11:]')
t.reader('lambda x:timeepoch("%s:00" % (x.replace(".","/")))')
t.viaje_temporal("Fecha")
# Temperatura Maxima
t.signal("TMaxima")
t.addfilter("T. Maxima (C)","T. Minima (C)",7)
t.addfilter(0)
# Temperatura minima
t.signal("TMinima")
t.addfilter("T. Minima (C)","Viento",7)
t.addfilter(0)
# Aado el Telemando a la lista
listado_telemandos.append(t)

