#!/usr/bin/env python2.4
#-*- coding: utf-8 -*-
##########################################################
#                 ACCIONES DE CARGA v1.0                 #
##########################################################
# Autor: Juan Miguel Taboada Godoy                       #
# Fecha: Malaga, 03 de agosto de 2006                    #
# Descripción: Fichero de configuración de Adquisión     #
# Versión: 2006080300                                    #
#                                                        #
# Codigo fuente bajo licencia GNU/GPL                    #
# Centrologic (Computational Logistic Center)            #
# http://www.centrologic.com - info@centrologic.com      #
##########################################################

# Importa la libreria de lectura/escritura de memorias
from src.lib.memoria_registros import *
# Pinto las gráficas
from src.etcbin.graficas import *
# Librerias
import os
import sys


# Argumentos {{{1
# Argument: silent {{{2
if (((len(sys.argv)==2) or (len(sys.argv)==3)) and (sys.argv[1]=='--silent')):
	debug=False
elif ((len(sys.argv)==3) and (sys.argv[2]=='--silent')):
	debug=False
else:
	debug=True
# }}}2
# Argument: last {{{2
if (((len(sys.argv)==2) or (len(sys.argv)==3)) and (sys.argv[1]=='--last')):
	last=True
elif ((len(sys.argv)==3) and (sys.argv[2]=='--last')):
	last=True
else:
	last=False
# }}}2
# }}}1

# Cargo de la memoria la listas de graficas pendientes por hacer
pendientes=memory_read(graficas,config.memoria())

# Hay trabajo por hacer?
if (pendientes==[]):
	# Si no hay nada pendiente, indico que no hay nada que hacer
	lista=[]
else:
	# Si no es la ultima ejecucion
	if (not last):
		# Reviso si ya puedo generar todas las graficas
		todas=True
		for grafica in graficas:
			if (not grafica.dotest()):
				todas=False
				break
		# Si no tengo todas las graficas, genero sólo las que tengo pendientes en memoria
		if (not todas):
			# Cargo de la memoria la listas de graficas pendientes por hacer
			lista=pendientes
		else:
			# Si las tengo todas, pues las hago todas
			lista=graficas
	else:
		# Si es la última ejecución hacemos todas las que se puedan
		lista=graficas

# Si hay algo que hacer
if (lista!=[]):
	# Vacía la memoria temporalmente
	memory_write([],config.memoria())
	
	# Genera las gráficas
	pendientes=[]
	for grafica in lista:
		grafica.set_debug(debug)
		try:
			grafica.out()
		except Exception,e:
			# Extraigo el nombre del fichero que ha podido crear R
			fichero=grafica.fileR()
			# Si dicho fichero existe
			if ((fichero!=None) and (os.path.exists(fichero))):
				# Elimino el fichero
				os.unlink(fichero)
			# Anoto el error
			print "Error generando la graficas %s: %s\n" % (grafica.nombre(),e)
			pendientes.append(grafica)
	
	memory_write(pendientes,config.memoria())
