#!/usr/bin/env python2.4
#-*- coding: utf-8 -*-
##########################################################
#                 ACCIONES DE CARGA v1.0                 #
##########################################################
# Autor: Juan Miguel Taboada Godoy                       #
# Fecha: Malaga, 03 de agosto de 2006                    #
# Descripción: Fichero de configuración de Adquisión     #
# Versión: 2006080300                                    #
#                                                        #
# Codigo fuente bajo licencia GNU/GPL                    #
# Centrologic (Computational Logistic Center)            #
# http://www.centrologic.com - info@centrologic.com      #
##########################################################

# Pinto las gráficas
from src.etcbin.graficas import *
import sys
import time
import datetime

# Función para completar los digitos esperados de un numero {{{2
def digitos(numero,digitos):
	# Mientras el número sea demasiado pequeño
	while (len(str(numero))<digitos):
		# Añado un cero
		numero="%s%s" % ('0',numero)
	# Devuelvo el número
	return numero
# }}}2
# Dada una fecha en formato "aaaa-mm-dd" + "hh:mm:ss", la transforma a fecha EPOCH {{{1
# Formato de entrada: 2005-10-14 + 19:13:32
# Formato de salida: 1023456427
def dateepoch(fecha,hora):
	# Extraigo la hora
	fecha=fecha.split("-")
	anyo=fecha[0]
	mes=fecha[1]
	dia=fecha[2]
	# Extraigo la hora
	thora=hora.split(":")
	hora=thora[0]
	minuto=thora[1]
	segundo=thora[2]
	# Creo la nueva fecha$
	nfecha=datetime.datetime(int(anyo),int(mes),int(dia),int(hora),int(minuto),int(segundo))
	# Transformo la fecha a EPOCH
	epoch=time.mktime(nfecha.timetuple())
	# Devuelvo el resultado
	return epoch
#}}}1
# Dada una fecha en formato EPOCH, la transforma a "aaaa-mm-dd" + "hh:mm:ss" {{{1
# Formato de entrada: 1023456427
# Formato de salida: 2005-10-14 + 19:13:32
def epochdate(timestamp):
	fechahora=datetime.datetime.fromtimestamp(float(timestamp))
	fechatuple=fechahora.timetuple()
	fecha="%s-%s-%s" % (fechatuple[0],digitos("%s" % fechatuple[1],2),digitos("%s" % fechatuple[2],2))
	hora="%s:%s:%s" % (digitos("%s" % fechatuple[3],2),digitos("%s" % fechatuple[4],2),digitos("%s" % fechatuple[5],2))
	return (fecha,hora)
# }}}1

inicio=dateepoch("2005-11-02","00:00:00")

fechas=[]
fechas.append(("Caudalimetro de la Arana",1131663600))
fechas.append(("Barranco Plano",1132527600))
fechas.append(("Rio-Gui",1130886000))
fechas.append(("Benagalbon",1140735600))
fechas.append(("Cutar Rebombeo",1131318000))
fechas.append(("Cutar Deposito",1131318000))
fechas.append(("Cutar Final de Conduccion",1134082800))
fechas.append(("Decantacion",1134082800))
fechas.append(("Torre del Mar",1143068400))
fechas.append(("Canuelo",1142895600))
fechas.append(("Santillan",1143154800))
fechas.append(("Ferrara",1143154800))
fechas.append(("Huerta de Julian",1149112800))
fechas.append(("Almachar Borge",1147989600))
fechas.append(("Rebombeo Almachar Borge",1146434400))
fechas.append(("La Cala",1149026400))
fechas.append(("Rincon",1149544800))
fechas.append(("Faro de Torrox",1149458400))
fechas.append(("Manzano",1149544800))
fechas.append(("El Buho",1148853600))
fechas.append(("EDAR Algarrobo",1150840800))
fechas.append(("Algarrobo",1149112800))

if (len(sys.argv)>1):
	print
	fechas.sort(lambda x, y: x[1]-y[1])
	for fecha in fechas:
		(t1,t2)=epochdate(fecha[1])
		print "%s => %s" % (t1,fecha[0])
	print
	sys.exit()


for grafica in graficas:
	# Anulo la ejecucción del test de existencia
	grafica.test(False)
	# Cambio el directorio de salida (sólo al directorio de históricos)
	grafica.dirdib(("src/tmp/dib/hist/",None))	# Directorio donde estarán las gráficas (Almenos 2 elementos, pueden ser None)
	# Activo el modo debug
	grafica.set_debug(True)

while (inicio<time.time()):
	(fecha,hora)=epochdate(inicio+3600*26)
	inicio=dateepoch(fecha,"00:00:00")
	for grafica in graficas:
		for fecha in fechas:
			if (fecha[0]==grafica.nombre()):
				if (fecha[1]<=inicio):
					grafica.viaje_temporal(inicio)
					grafica.sizex(True,True,True,True)
					grafica.out()
				break

print "FINALIZADO"
