#!/usr/bin/env python
#-*- coding: iso8859-15 -*-
##########################################################
#                  ADQUIRIR FTP v1.0                     #
##########################################################
# Autor: Juan Miguel Taboada Godoy                       #
# Fecha: Malaga, 05 de Septiembre de 2006                #
# Descripcin: Configurador de adquisicion de datos      #
# Versin: 2006090500                                    #
#                                                        #
# Codigo fuente bajo licencia GNU/GPL                    #
# Centrologic (Computational Logistic Center)            #
# http://www.centrologic.com - info@centrologic.com      #
##########################################################

# Libreria de Telemandos configurados aqui
from src.telemandos.FILE_FTP import CONFIG,TELEMANDO

# Genero la configuracion base
config=CONFIG()

# Debug
config.set_debug(True)	# Debug de la clase hija

# Detalles de los Telemandos
config.download_tempo(60*60*24)		# Descargar registros cada 24 horas

# Config base: Servidor SMS
config.user("user")				# Usuario
config.passwd("password")		# Clave
config.port(21)			    	# Puerto

# Directorios de SMSs y REGISTROS
config.recv("/grafista+")					# Recibir registros
config.save("/GUARDADOS")			# Guardar registros recibidos
config.dirtemp("src/tmp/reg/")		# Destino de los ficheros temporales
# Memoria interna
config.memoria("src/tmp/memory/adquirir_ftp.dat")

# Logueo
config.dirlog(["src/tmp/log/dat/"])
config.cabecera_log("adquirir_ftp")

# Tiempos de espera
config.timeout_espera_ftp(300)	# Los ciclos son de 1 segundo

# Cada Telemando ejecuta este mismo chequeo por seguridad al cargar
# la config por defecto (no obstante me parece mas correcto hacer un chequeo previo)
config.check()
