#!/usr/bin/env python
#-*- coding: iso8859-15 -*-
##########################################################
#                ADQUIRIR PESYR v1.0                     #
##########################################################
# Autor: Juan Miguel Taboada Godoy                       #
# Fecha: Malaga, 12 de julio de 2006                     #
# Descripcin: Configurador de Grafista                  #
# Versin: 2006071200                                    #
#                                                        #
# Codigo fuente bajo licencia GNU/GPL                    #
# Centrologic (Computational Logistic Center)            #
# http://www.centrologic.com - info@centrologic.com      #
##########################################################

# Libreria de Telemandos configurados aqui
from src.telemandos.PESYR_FTP import CONFIG,TELEMANDO

# Genero la configuracion base
config=CONFIG()

# Debug
config.set_debug(True)	# Debug de la clase hija

# Detalles de los Telemandos
config.download_tempo(60*60*24)		# Descargar registros cada 24 horas

# Config base: Servidor SMS
config.smsserver("192.168.x.y")		# Servidor(SMS)
config.smsport(21)    				# Puerto (SMS)
config.smsuser("user")				# Usuario (SMS)
config.smspasswd("password")		# Clave (SMS)

# Config base: Servidor REGISTROS
config.regserver("192.168.x.y")		# Servidor (REG)
config.regport(21)    				# Puerto (REG)
config.reguser("user")				# Usuario (REG)
config.regpasswd("password")		# Clave (REG)

# Directorios de SMSs y REGISTROS
config.sms_temp("sms.tmp")			# Fichero temporal para crear mensajes SMSs (localmente)
config.sms_remoto("sms_recol")		# Cabecera para el fichero SMSs temporal en el servidor remoto
config.sms_send("/")				# Envo de SMSs
config.sms_bien("/BIEN")			# SMS enviado correctamente
config.sms_mal("/MAL")				# Fallo en el envo del SMS
config.reg_lock("recolector.lck")	# Candado de bloqueo del recolector
config.reg_recv("/")				# Recibir registros
config.reg_save("/GUARDADOS")		# Guardar registros recibidos
config.dirtemp("src/tmp/reg/")		# Destino de los ficheros temporales

# Ciclos de espera
config.espera_sms_recogido(6)		# Espera a que un SMS sea recogido por el motor (x10 seg)
config.espera_sms_procesado(12)		# Espera a que un SMS sea procesado por el motor (x10 seg)
config.espera_reg_referencia(9)		# Espera a que una referencia de registro sea creado por el motor (x10 seg)
config.espera_reg_registro(50)		# Espera a que un registro sea recogido y procesado por el motor (x10 seg)

# Memoria interna
config.memoria("src/tmp/memory/adquirir_pesyr.dat")

# Borrado de registros del telemando a los bytes indicados (500 = 500 bytes)
config.borrado(500*1000)	# 500 Kilobytes

# Logueo
config.dirlog(["src/tmp/log/dat/"])
config.cabecera_log("pesyr")

# Cada Telemando ejecuta este mismo chequeo por seguridad al cargar
# la config por defecto (no obstante me parece mas correcto hacer un chequeo previo)
config.check()
