#!/usr/bin/env python
#-*- coding: iso8859-15 -*-
##########################################################
#                  ADQUIRIR RED v1.0                     #
##########################################################
# Autor: Juan Miguel Taboada Godoy                       #
# Fecha: Malaga, 15 de enero de 2007                     #
# Descripcin: Fichero de configuracin de Adquisin de  #
# datos de dispositivos de red                           #
# Versin: 2007011501                                    #
#                                                        #
# Codigo fuente bajo licencia GNU/GPL                    #
# Centrologic (Computational Logistic Center)            #
# http://www.centrologic.com - info@centrologic.com      #
##########################################################

# Libreria de Telemandos configurados aqui
from src.telemandos.NETSTATISTICS import CONFIG,TELEMANDO

# Genero la configuracion base
config=CONFIG()

# Debug
config.set_debug(True)	# Debug de la clase hija

# Definicin de los ficheros de datos
config.devnet("/proc/net/dev")
config.pingfile("pings.dat")

# Logueo
config.dirlog(["src/tmp/log/dat/"])
config.cabecera_log("adquirir_red")

# Cada Telemando ejecuta este mismo chequeo por seguridad al cargar
# la config por defecto (no obstante me parece mas correcto hacer un chequeo previo)
config.check()

# Inicializo algunos valores
listado_telemandos=[]

# Definiciones {{{1
# Variables {{{2
band_in="bi"
band_out="bo"
packet_in="pi"
packet_out="po"
ping_digital="hp"		# Hay ping?
ping_enviados="pe"
ping_recibidos="pr"
ping_perdidos="pp"
ping_minimo="pm"
ping_medio="pa"
ping_maximo="px"
ping_dispotivio="pv"
# }}}2
# Dispositivos {{{2
eth0="eth0"
eth1="eth1"
eth2="eth2"
eth3="eth3"
eth4="eth4"
tun0="tun0"
tun1="tun1"
tun2="tun2"
tun3="tun3"
tun4="tun4"
# }}}2
# }}}1

