#!/usr/bin/env python
#-*- coding: iso8859-15 -*-
##########################################################
#                  CONFIG SQL v1.0                       #
##########################################################
# Autor: Juan Miguel Taboada Godoy                       #
# Fecha: Malaga, 12 de julio de 2006                     #
# Descripcin: Configurador de Grafista                  #
# Versin: 2006080300                                    #
#                                                        #
# Codigo fuente bajo licencia GNU/GPL                    #
# Centrologic (Computational Logistic Center)            #
# http://www.centrologic.com - info@centrologic.com      #
##########################################################

# Libreria del Cargador
from src.cargadores.OUT_DB_MYSQL import CONFIG,CARGADOR

# Genero la configuracion base
config=CONFIG()

# Debug
config.set_debug(True)	# Debug de la clase hija

# Detalles del cargador
config.dirreg("data/reg/")	# Directorio que coniene los registros
config.sql_host("localhost")# SQL: Host
config.sql_port(3306)		# SQL: Puerto
config.sql_socket("auto")	# SQL: Socket
config.sql_user("likindoy")
config.sql_passwd("likindoyclave")
config.sql_db("likindoy_test")
config.sql_table("datos")

# Configuro la frecuencia estndar de muestreo para todas las seales
config.frecuencia(60*15)

# Logueo
config.dirlog(["src/tmp/log/dat/"])
config.cabecera_log("cargar_sql")

# Cada Telemando ejecuta este mismo chequeo por seguridad al cargar
# la config por defecto (no obstante me parece mas correcto hacer un chequeo previo)
config.check()

# Creo el objeto cargador
sql=CARGADOR()
sql.config(config)
