#!/usr/bin/env python
#-*- coding: iso8859-15 -*-
##########################################################
#                 CONFIG GRAFICAS v1.0                   #
##########################################################
# Autor: Juan Miguel Taboada Godoy                       #
# Fecha: Malaga, 04 de agosto de 2006                    #
# Descripcion: Fichero de configuracion de graficas      #
# Version: 2006080400                                    #
#                                                        #
# Codigo fuente bajo licencia GNU/GPL                    #
# Centrologic (Computational Logistic Center)            #
# http://www.centrologic.com - info@centrologic.com      #
##########################################################

# Importo las senales disponibles
from graficas_default import *

# Documentacion {{{1
# Resolucion(851) - Ancho de margenes(70) - 1 = Ancho de la caja de graficas
# La caja de graficas tiene N casillas, mas una en el extremo derecho, mas una en el extremo izq (para 24 casillas de 1 horas son 26 casillas)
# Para calcular los pixeles que quedan para la graficas = size-1-30(MargenD)-40(MargenI)
# }}}1
# Preconfig {{{1
# Colores
blanco=0
negro=1
rojo=2
verde=3
azul=4
azul_claro=5
magenta=6
amarillo=7
gris=8
verde_oscuro="darkgreen"

color_b1=azul
color_b2=rojo
color_b3="darkgreen"
color_b4="darkorange3"
color_b5= "darkcyan"
color_nivel=negro
color_presion="darkmagenta"
color_caudal=azul
color_frecuencia = "darkcyan"
color_potencia = "gray50"
color_cloro = rojo

# Forma de las lineas
escalera="escaleraPasado"
lineal="lineal"
evento="evento"

# Forma de los puntos (media, maximo, minimo)
circuloV=1
triangulo_arribaV=2
cruz=3
equisV=4
romboV=5
triangulo_abajoV=6
cuadrado_equis=7
cruz_equis=8
rombo_cruz=9
circulo_cruz=10
triangulo_arriba_abajo=11
cuadrado_cruz=12
circulo_cruz=13
cuadrado_triangulo=14
cuadrado=15
circulo_mediano=16
triangulo=17
rombo=18
circulo_grande=19
circulo_pequeno=20
circuloC=21
cuadradoC=22
romboC=23
triangulo_arribaC=24
triangulo_abajoC=25
asterisco=26
punto=27
cero1=28
cero2=29
cero3=30
mas='"+"'
menos='"-"'
dospuntos='":"'
vertical='"|"'
porciento='"%"'
sostenido='"#"'


# Tamano de los puntos (media, maximo, minimo)
puntos_pequenios= 0.5
puntos_medianos = 1.3
puntos_grandes = 1.8

# Tipo de lineas
solida=1
puntos1=2
puntos2=3
puntos3=4

# Maximos y minimos
maximos=(triangulo_arribaC,cuadradoC,True)
minimos=(triangulo_abajoC,cuadradoC,True)
medias=(circuloC,False)
mediasUnica=(circuloC,True)

# Resolucion
size=851
res_1pxminuto=1631
res_otra=1241

# Evento normal
evento_valor=[0,1]
evento_color1=("black",[None,negro],None)
evento_color0=("black",[negro,None],None)

#Evento color cobertura
#cobertura_valor=[0,32]
#digital_cobertura2=[]
#for i in range(0,100,5):
#	digital_cobertura2.append("gray%s" % (i))
#cobertura_color=("black",digital_cobertura2)

cobertura_valor=[0,12,16,32]
cobertura_color=("black",["black","gray50",None],None)

#digital_cobertura2=[]
#for i in range(0,100,5):
#	digital_cobertura2.append("gray%s" % (i))
#cobertura_color=("black",digital_cobertura2)


#Evento color Trafico de red
evento_valor_trafico_red=[0,1000,2200,4400,999999]
evento_trafico_red=("black",[None,"gray70","gray30","black"],None)

# Lista de graficas
graficas=[]
# }}}1

### GENERAL ### #######################################################################################

# Minima {{{1
g=GRAFICA("Minima",s)
g.config(config)
g.leyendaColumnas(5)
g.sizey(-10,40,5,2.5)
g.addaxis(0,"izq","Temperatura")
g.addaxis(0,"inf","Dias")
g.sizex("date:10/07/2007_07:50:00","date:25/07/2007_07:50:00","dias","%d/%m/%Y")

g.test("INM_TMinima","date:10/07/2007_07:50:00","date:25/07/2007_07:50:00",-50,50)

g.addline("Temperatura Minima","INM_TMinima","a",escalera,color_caudal,1,solida)
g.leyenda("Temperatura Minima")

g.outpng("Temperatura Minima - %iayer.png","Temperatura Minima - %ayer",res_otra,700)
graficas.append(g)
# }}}1
# Maxima {{{1
g=GRAFICA("Maxima",s)
g.config(config)
g.leyendaColumnas(5)
g.sizey(-10,40,5,2.5)
g.addaxis(0,"izq","Temperatura")
g.addaxis(0,"inf","Dias")
g.sizex("date:10/07/2007_07:50:00","date:25/07/2007_07:50:00","dias","%d/%m/%Y")

g.test("INM_TMaxima","date:10/07/2007_07:50:00","date:25/07/2007_07:50:00",-50,50)

g.addline("Temperatura Maxima","INM_TMaxima","a",escalera,rojo,1,solida)
g.leyenda("Temperatura Maxima")

g.outpng("Temperatura Maxima - %iayer.png","Temperatura Maxima - %ayer",res_otra,700)
graficas.append(g)
# }}}1

### MEZCLAS ### #######################################################################################

# Minimax {{{1
g=GRAFICA("Minimax",s)
g.config(config)
g.leyendaColumnas(5)
g.sizey(-10,40,5,2.5)
g.addaxis(0,"izq","Temperatura")
g.addaxis(0,"inf","Dias")
g.sizex("date:10/07/2007_07:50:00","date:25/07/2007_07:50:00","dias","%d/%m/%Y")

g.test("INM_TMinima","date:10/07/2007_07:50:00","date:25/07/2007_07:50:00",-50,50)

g.addline("Temperatura Minima","INM_TMinima","a",escalera,color_caudal,1,solida)
g.addline("Temperatura Maxima","INM_TMaxima","a",escalera,rojo,1,solida)
g.leyenda("Temperatura Minima")
g.leyenda("Temperatura Maxima")

g.outpng("Temperatura Minimax - %iayer.png","Temperatura Minimax - %ayer",res_otra,700)
graficas.append(g)
# }}}1

