#!/usr/bin/env python
#-*- coding: iso8859-15 -*-
##########################################################
#                 CONFIG GRAFICAS v1.0                   #
##########################################################
# Autor: Juan Miguel Taboada Godoy                       #
# Fecha: Malaga, 11 de agosto de 2006                    #
# Descripción: Fichero de configuración de gráficas def  #
# Versión: 2006081100                                    #
#                                                        #
# Codigo fuente bajo licencia GNU/GPL                    #
# Centrologic (Computational Logistic Center)            #
# http://www.centrologic.com - info@centrologic.com      #
##########################################################

# Importo las señales disponibles
from senales import *
# Importo el conector a la base de datos
from lector_sql import *
# Libreria para el procesado de las gráficas
from src.graficas.OUT_R import *

# Genero la configuracion base
config=CONFIG()

# Debug
config.set_debug(True)	# Debug de la clase hija

# Detalles de las gráficas
config.dirdib(("src/tmp/dib/dib/","src/tmp/dib/hist/","src/tmp/dib/bak/"))	# Directorio de las gráficas (almenos 2 elementos, pueden ser None)
config.resolution(851,600)
config.sizex("date:ayer_06:00:00","date:hoy_06:00:00","horas","%H:%M")
config.sizey(-10,200)
config.margenes(40,30,30,40)	# Orden: inf, izq, sup, der
config.inch(97.8)
config.eventoCrece(16)
config.eventoTexto(8)
config.leyendaCrece(16)
config.leyendaColumnas(4)
config.grid(True)
config.lector(lector)
config.memoria("src/tmp/memory/graficas_R.dat")
config.test("Cobertura","date:hoy_00:00:00","date:hoy_06:00:00",0,32,True) # Este formato sólo permite horas exactas

# Logueo
config.dirlog(["src/tmp/log/dat/"])
config.cabecera_log("graficas")

# Compruebo la configuración
config.check()
