#!/usr/bin/env python2.4
#-*- coding: iso8859-15 -*-

import os
import sys
import Image

# Class to process an image
## \internal
## Class to process an image
class ReadImage:
	# Creates the new object
	## Creates the new object
	## \param self -
	## \param filename Filename
	## \param ini Pixel to start
	## \param end Pixel to end
	## \param linecolor Color of the line
	def __init__(self,filename,ini,end,linecolor):
		# Get config
		(xini,yini)=ini
		(xend,yend)=end
		# Repair config
		xini=xini+1
		yini=yini+1
		xend=xend-1
		yend=yend-1
		# Remember config
		self.__xini=xini
		self.__xend=xend
		self.__yini=yini
		self.__yend=yend
		self.__linecolor=linecolor
		# Open the file
		self.__image=Image.open(filename)
		(width,height)=self.__image.size
		# Start values
		self.__values=None
		# Check limits
		if (not (xini>0 and xini<width and xend>0 and xend<width and xini<xend and yini>0 and yini<height and yend>0 and yend<height and yini<yend)):
			raise IOError,"Error en el limite de la imagen, la imagen es de tamano %sx%s y los limites datos son incorectos: inicio(%s,%s) fin(%s,%s)" % (width,height,xini,yini,xend,yend)
		print "%s %s %s %s" % (filename, (xini,yini), (xend,yend), self.__linecolor)

	# Read values
	## Read values
	## \param self -
	def read(self):
		# Process the file
		values=[]
		for x in range(self.__xini,self.__xend):
			# Restart counter
			value=None
			for y in range(self.__yini,self.__yend):
				# Get another pixel
				pixel=self.__image.getpixel((x,y))
				# Check if we reached to the point
				if (pixel==self.__linecolor):
					value=self.__yend-y+1
					values.append(value)
					break
		# Return the result
		self.__values=values
	
	# Return the matrix with pixels
	## Return the matrix with pixels
	## \param self -
	def getpixel(self):
		# If we are asked without reading
		if (self.__values==None):
			# We read first
			self.read()
		# Return values
		return self.__values

	# Get the matrix with values
	## Get the matrix with values
	## \param self -
	## \param horizontalpx Horizontal size of box
	## \param verticalpx Vertical size of box
	## \param horizontaldif Horizontal difference between ticks
	## \param verticaldif Vertical difference between ticks
	def get(self,horizontalpx,verticalpx,horizontaldif,verticaldif):
		# If we are asked without reading
		if (self.__values==None):
			# We read first
			print self.__values
			self.read()
			
		# Get value per pixel
		size_horizontal_pixel=horizontaldif/horizontalpx
		size_vertical_pixel=verticaldif/verticalpx
		# Create the matrix
		matrix=[]
		counter=0
		for element in self.__values:
			# Keep counting on X axis
			counter+=size_horizontal_pixel
			# Make the tuple
			tuple=(counter,element*size_vertical_pixel)
			# Save the tuple
			matrix.append(tuple)
		# Return the resulting matrix
		return matrix

